New URL for NEMO forge!   http://forge.nemo-ocean.eu

Since March 2022 along with NEMO 4.2 release, the code development moved to a self-hosted GitLab.
This present forge is now archived and remained online for history.
makenemo on Ticket #1762 – Attachment – NEMO

Ticket #1762: makenemo

File makenemo, 11.0 KB (added by rblod, 8 years ago)
Line 
1#!/bin/bash
2#set -x
3set -o posix
4#set -u
5#set -e
6#+
7#
8# ===============
9# makenemo
10# ===============
11#
12# --------------------------
13# Compile NEMO
14# --------------------------
15#
16# SYNOPSIS
17# ========
18#
19# ::
20#
21#  $ makenemo
22#
23#
24# DESCRIPTION
25# ===========
26#
27#
28# This script aims :
29#
30# - to choose MYCONFIG
31# - to choose compiler options
32# - to create the CONFIG/MYCONFIG/WORK directory
33# - to compile this configuration
34#
35#  Variables used :
36#
37#  From user input
38#
39# - NEW_CONF    : configuration to be created
40# - REF_CONF    : reference configuration to build the new one from
41# - CMP_NAM     : compiler name
42# - NBR_PRC     : number of processes used to compile
43# - USP_CONF    : unsupported (external) configuration to build the new one from
44# - NEM_SUBDIR  : NEMO subdirectory used (specified)
45#
46#  Locally defined :
47#
48# - TAB         : NEMO subdirectory used (read)
49# - MAIN_DIR    : self explaining
50# - CONFIG_DIR  :   "    "    "
51# - MODELES_DIR :   "    "    "
52# - TOOLS_DIR   :   "    "    "
53# - NEMO_DIR    :   "    "    "
54# - REMOTE_CTL  : URL link to a remote resource list for an external configuration
55#                 which is not part of the reference suite
56# - LOCAL_REF   : Nearest reference configuration to an external configuration
57#                 which is not part of the reference suite
58#                 (used to populate work directories if remote access is not available)
59#
60# EXAMPLES
61# ========
62#
63# ::
64#
65#  $ ./makenemo -m ifort_osx - j3 -n ORCA2_LIM
66#
67#
68# TODO
69# ====
70#
71# option debug
72#
73#
74# EVOLUTIONS
75# ==========
76#
77# $Id: makenemo 5144 2015-03-11 15:51:28Z timgraham $
78#
79#
80#
81#   * creation
82#
83#-
84
85#-
86#- Initialization of the options ---
87x_d="";
88x_h="";
89x_n="";
90x_r="";
91x_u="";
92x_m="";
93x_t="";
94x_c="";
95x_j=1;
96x_e="none";
97x_s=NEMO;
98x_v=1;
99
100#- Local variables ---
101b_n=$(basename ${0})
102OPTIND=1
103MAIN_DIR=$(cd $(dirname "$0"); pwd)
104MAIN_DIR=${MAIN_DIR%/SETTE*}
105MAIN_DIR=${MAIN_DIR%/TOOLS*}
106MAIN_DIR=${MAIN_DIR%/CONFIG*}
107export MAIN_DIR
108#
109export CONFIG_DIR=${MAIN_DIR}/CONFIG
110export TOOLS_DIR=${MAIN_DIR}/TOOLS
111export COMPIL_DIR=${MAIN_DIR}/TOOLS/COMPILE
112export NEMO_DIR=${MAIN_DIR}/${x_s}
113export AGRIFUSE=10
114declare -a TAB
115declare -a REMOTE_CTL
116declare -a LOCAL_REF
117list_key=0
118chk_key=1
119#-
120#- FCM and functions location ---
121export PATH=${MAIN_DIR}/EXTERNAL/fcm/bin:$PATH
122
123#-
124#- Choice of the options ---
125while getopts :hd:n:r:u:m:j:e:s:v:t:k: V
126do
127    case $V in
128   (h) x_h=${OPTARG};
129        echo "Usage   : "${b_n} \
130       " [-h] [-n name] [-m arch] [-d "dir1 dir2"] [-r conf] [-u conf] [-s Path] [-e Path] [-j No] [-v No] [-k 0/1]";
131   echo " -h           : help";
132   echo " -h institute : specific help for consortium members";
133   echo " -n name      : config name, [-n help] to list existing configurations";
134   echo " -m arch      : choose compiler, [-m help] to list existing compilers";
135   echo " -d dir       : choose NEMO sub-directories";
136   echo " -r conf      : choose reference configuration";
137   echo " -u conf      : choose an unsupported (external) configuration";
138        echo " -s Path      : choose alternative location for NEMO main directory";
139        echo " -e Path      : choose alternative location for MY_SRC directory";
140        echo " -j No        : number of processes used to compile (0=nocompilation)";
141        echo " -v No        : set verbosity level for compilation [0-3]";
142        echo " -k 0/1       : used cpp keys check (default = 1 -> check activated)";
143   echo " -t dir       : temporary directory for compilation"
144   echo "";
145   echo "Example to install a new configuration MY_CONFIG";
146   echo "with OPA_SRC and LIM_SRC_2 ";
147   echo "makenemo -n MY_CONFIG -d \"OPA_SRC LIM_SRC_2\"";
148   echo "";
149   echo "Available configurations :"; cat ${CONFIG_DIR}/cfg.txt;
150   echo "";
151        echo "Available unsupported (external) configurations :"; cat ${CONFIG_DIR}/uspcfg.txt;
152   echo "";
153   echo "Example to remove bad configuration ";
154   echo "./makenemo -n MY_CONFIG clean_config";
155   echo "";
156   echo "Example to clean ";
157   echo "./makenemo clean";
158   echo "";
159   echo "Example to list the available keys of a CONFIG ";
160   echo "./makenemo list_key";
161   echo "";
162   echo "Example to add and remove keys";
163   echo "./makenemo add_key \"key_iomput key_mpp_mpi\" del_key \"key_agrif\" ";
164   echo "";
165   echo "Example to add and remove keys for a new configuration, and do not compile";
166   echo "./makenemo -n MY_CONFIG -j0 add_key \"key_iomput key_mpp_mpi\" del_key \"key_agrif\" ";
167   echo "";
168   . ${COMPIL_DIR}/Flist_archfile.sh ${x_h}  ;
169   echo "";
170   echo "Default : previous configuration and compiler";
171   exit 0;;
172   (d)  x_d=${OPTARG};;
173   (n)  x_n=${OPTARG};;
174   (r)  x_r=${OPTARG};;
175   (u)  x_u=${OPTARG};;
176   (m)  x_m=${OPTARG};;
177   (j)  x_j=${OPTARG};;
178   (t)  x_t=${OPTARG};;
179   (e)  x_e=${OPTARG};;
180   (s)  x_s=${OPTARG};;
181   (v)  x_v=${OPTARG};;
182   (k)  chk_key=${OPTARG};;
183   (:)  echo ${b_n}" : -"${OPTARG}" option : missing value" 1>&2;
184   exit 2;;
185   (\?) echo ${b_n}" : -"${OPTARG}" option : not supported" 1>&2;
186   exit 2;;
187    esac
188done
189shift $(($OPTIND-1));
190
191while [ ${#1} -gt 0 ]   # Get clean, clean_config options
192do
193    case "$1" in
194   clean)
195       x_c="--$1"
196       ;;
197   clean_config)
198       . ${COMPIL_DIR}/Fclean_config.sh
199       exit
200       ;;
201   add_key)
202            # Checking if argument has anything other than whitespace
203            [[ ! "$2" =~ ^\ +$ ]] && { list_add_key=$2; export ${list_add_key}; }
204       shift
205       ;;
206   del_key)
207            # Checking if argument has anything other than whitespace
208            [[ ! "$2" =~ ^\ +$ ]] && { list_del_key=$2; export ${list_del_key}; }
209       shift
210       ;;
211   list_key)
212       list_key=1
213       ;;
214   *)
215       echo " \"$1\" BAD OPTION"
216       exit
217       ;;
218
219    esac
220    shift
221done
222
223
224#-
225#- Go to NEMOGCM/config directory ---
226cd ${CONFIG_DIR}
227
228#-
229#- Initialisation from input ---
230export NEW_CONF=${x_n}
231NBR_PRC=${x_j}
232CMP_NAM=${x_m}
233NEM_SUBDIR=${x_d}
234REF_CONF=${x_r}
235USP_CONF=${x_u}
236NEMO_TDIR=${x_t:-$NEMO_TDIR}
237export NEMO_TDIR=${NEMO_TDIR:-$CONFIG_DIR}
238export NEMO_DIR=${MAIN_DIR}/${x_s}
239
240#- Check if the tool or the compiler exist or list it
241if [ "${NEW_CONF}" == help ] ; then
242    echo "Available configurations :"
243    cat ${CONFIG_DIR}/cfg.txt
244    echo
245    echo "Available unsupported (external) configurations :" 
246    cat ${CONFIG_DIR}/uspcfg.txt
247    exit
248fi
249[ "${CMP_NAM}" ==  help ] && . ${COMPIL_DIR}/Flist_archfile.sh all && exit
250
251#-
252#- Choose a default configuration if needed ---
253#- ORCA2_LIM or last one used ---
254. ${COMPIL_DIR}/Fcheck_config.sh cfg.txt ${NEW_CONF} || exit
255
256if [ ${#NEW_CONF} -eq 0 ] ; then
257    if [ ${#NEM_SUBDIR} -eq 0 ] && [ ${#REF_CONF} -eq 0 ] && [ ${#USP_CONF} -eq 0 ] ; then
258   echo "You are installing a new default (ORCA2_LIM) configuration"
259   ind=0
260   . ${COMPIL_DIR}/Fread_dir.sh OPA_SRC    YES
261   . ${COMPIL_DIR}/Fread_dir.sh LIM_SRC_2   YES
262   . ${COMPIL_DIR}/Fread_dir.sh LIM_SRC_3   NO
263   . ${COMPIL_DIR}/Fread_dir.sh TOP_SRC    NO
264   . ${COMPIL_DIR}/Fread_dir.sh NST_SRC    YES
265   . ${COMPIL_DIR}/Fread_dir.sh OFF_SRC    NO
266   . ${COMPIL_DIR}/Fread_dir.sh OOO_SRC    NO
267   . ${COMPIL_DIR}/Fread_dir.sh SAS_SRC    NO
268   REF_CONF=ORCA2_LIM
269    elif [ ${#NEM_SUBDIR} -gt 0 ] && [ ${#REF_CONF} -eq 0 ] && [ ${#USP_CONF} -eq 0 ] ; then
270   echo "You are  installing a new configuration based on ORCA2_LIM"
271   TAB=( ${NEM_SUBDIR} )
272   REF_CONF=ORCA2_LIM
273    elif [ ${#NEM_SUBDIR} -eq 0 ] && [ ${#REF_CONF} -gt 0 ]; then
274   echo "You are  installing a new configuration based on ${REF_CONF}"
275   . ${COMPIL_DIR}/Fcopy_dir.sh ${REF_CONF}
276    elif [ ${#NEM_SUBDIR} -eq 0 ] && [ ${#USP_CONF} -gt 0 ]; then
277   echo "You are  installing a new configuration based on the unsupported (external) ${USP_CONF}"
278   . ${COMPIL_DIR}/Fcopy_extdir.sh ${USP_CONF} 
279        #echo "TTT " ${TAB}
280        #echo "RRR " ${REMOTE_CTL}
281        #echo "LLL " ${LOCAL_REF}
282    fi
283    NEW_CONF=${x_n}
284
285    if [ ${#USP_CONF} -gt 0 ]; then
286      . ${COMPIL_DIR}/Fmake_extconfig.sh ${NEW_CONF} ${LOCAL_REF}
287      . ${COMPIL_DIR}/Ffetch_extdir.sh ${NEW_CONF} ${REMOTE_CTL} 
288    else
289      . ${COMPIL_DIR}/Fmake_config.sh ${NEW_CONF} ${REF_CONF}
290    fi
291else
292    sed -e "/${NEW_CONF} /d"  ${CONFIG_DIR}/cfg.txt >  ${COMPIL_DIR}/cfg.tmp
293    \m${COMPIL_DIR}/cfg.tmp  ${CONFIG_DIR}/cfg.txt
294fi
295
296#-
297#- Save new configuration and directories names ---
298echo ${NEW_CONF} ${TAB[*]} >> ${CONFIG_DIR}/cfg.txt
299
300#-
301#- Create the WORK ---
302#- Clean links and librairies ---
303#- Creating the good links, at first on OPA_SRC ---
304. ${COMPIL_DIR}/Fmake_WORK.sh ${x_e} ${NEW_CONF} ${TAB[*]} || exit
305
306. ${COMPIL_DIR}/Fmake_bld.sh ${CONFIG_DIR} ${NEW_CONF}  ${NEMO_TDIR} || exit
307
308# build the complete list of the cpp keys of this configuration
309if [ $chk_key -eq 1 ] ; then
310    for i in $( grep "^ *#.* key_" ${NEW_CONF}/WORK/* ) 
311    do
312   echo $i | grep key_ | sed -e "s/=.*//"
313    done | sort -d | uniq > ${COMPIL_DIR}/full_key_list.txt
314    if [ $list_key -eq 1 ]; then
315   cat ${COMPIL_DIR}/full_key_list.txt
316   exit 0
317    fi
318fi
319
320#- At this stage new configuration has been added, we add or remove keys
321[ ! -z "${list_add_key}" ] && { . ${COMPIL_DIR}/Fadd_keys.sh ${NEW_CONF} add_key ${list_add_key}; }
322[ ! -z "${list_del_key}" ] && { . ${COMPIL_DIR}/Fdel_keys.sh ${NEW_CONF} del_key ${list_del_key}; }
323
324#- check that all keys are really existing...
325if [ $chk_key -eq 1 ] ; then
326    for kk in $( cat ${NEW_CONF}/cpp_${NEW_CONF}.fcm )
327    do
328   if [ "$( echo $kk | cut -c 1-4 )" == "key_" ]; then
329       kk=${kk/=*/}
330       nb=$( grep -c $kk ${COMPIL_DIR}/full_key_list.txt )
331       if [ $nb -eq 0 ]; then
332      echo
333      echo "E R R O R : key "$kk" is not found in ${NEW_CONF}/WORK routines..."
334      echo "we stop..."
335      echo
336      exit 1
337       fi
338   fi
339    done
340fi
341
342#- At this stage cpp keys have been updated. we can check the arch file
343#- When used for the first time, choose a compiler ---
344. ${COMPIL_DIR}/Fcheck_archfile.sh arch_nemo.fcm cpp.fcm ${CMP_NAM} || exit
345
346#- At this stage the configuration has beeen chosen
347#- We coose the default light file
348export USEBLD=bldxag.cfg
349
350#- We look after agrif
351grep key_agrif ${COMPIL_DIR}/cpp.fcm && export AGRIFUSE=1 && export USEBLD=${USEBLD/xag/}
352. ${COMPIL_DIR}/Fprep_agrif.sh ${NEW_CONF} ${NEMO_TDIR} || exit
353
354#-
355#_ END OF CONFIGURATION PHASE
356#_
357
358#-
359#- Compile ---
360
361if [ "${NBR_PRC}" -gt 0 ]; then
362    cd ${NEMO_TDIR}/${NEW_CONF} || cd -
363
364#if AGRIF we do a first preprocessing
365    if [ ${#x_c} -eq 0 ]; then
366       if [ "$AGRIFUSE" == 1 ]; then
367          fcm build --ignore-lock  -j 1 ${COMPIL_DIR}/bld_preproagr.cfg ||{ cd - ; exit ;}
368          echo ""
369          echo "---------------------------------"
370          echo "CONV preprocessing successfull !!"
371          echo "---------------------------------"
372          echo ""
373       fi
374    fi
375    fcm build ${x_c} --ignore-lock -v ${x_v} -j ${NBR_PRC} ${COMPIL_DIR}/$USEBLD || cd -
376    [ -f ${NEMO_TDIR}/${NEW_CONF}/BLD/bin/nemo.exe ] && ln -sf ${NEMO_TDIR}/${NEW_CONF}/BLD/bin/nemo.exe  ${CONFIG_DIR}/${NEW_CONF}/EXP00/opa
377
378#add remove for clean option
379    if  [ ${#x_c} -ne 0 ]; then
380        rm -rf ${NEMO_TDIR}/${NEW_CONF}/OPAFILES
381        rm -rf ${NEMO_TDIR}/${NEW_CONF}/WORK
382        rm -rf ${NEMO_TDIR}/${NEW_CONF}/BLD
383        rm -rf ${NEMO_TDIR}/${NEW_CONF}/EXP00/opa
384        rm -f ${COMPIL_DIR}/*history ${COMPIL_DIR}/*fcm ${COMPIL_DIR}/*txt
385        echo "cleaning ${NEW_CONF} WORK, BLD"
386    fi
387
388fi
389
390#- Come back to original directory ---
391cd -
392
393#-
394#- Unset variables
395${COMPIL_DIR}/Fclean_var.sh
396
397